unit Unit1;

{$MODE Delphi}

interface

uses
  LCLIntf, LCLType, LMessages, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls;

type
  TForm1 = class(TForm)
    Button1: TButton;
    GroupBox1: TGroupBox;
    Virtualis: TCheckBox;
    Abstrack: TCheckBox;
    Overrides: TCheckBox;
    Dinamikus: TCheckBox;
    RadioGroup1: TRadioGroup;
    Nev: TEdit;
    Label1: TLabel;
    Param: TEdit;
    Label2: TLabel;
    Memo1: TEdit;
    Label3: TLabel;
    ComboBox1: TComboBox;
    uzenet: TCheckBox;
    ComboBox2: TComboBox;
    Label4: TLabel;
    procedure RadioGroup1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure ComboBox2Change(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  s,s1,s2,s3,s4,s5,res:string;
implementation

{$R *.lfm}

procedure TForm1.RadioGroup1Click(Sender: TObject);
begin
     if Virtualis.Checked then
     begin
          if uzenet.Checked then
          begin
               Overrides.Checked := false;
               Dinamikus.Checked := false;
          end;
        Dinamikus.Checked := false;
        s1:= 'virtual; ';
     end
     else
         //Dinamikus.Checked := true;
         s1:='';
     if Abstrack.Checked then
        s2:= 'abstract; '
     else
         s2:='';
     if Overrides.Checked then
     begin
          if uzenet.Checked then
          begin
               Virtualis.Checked := false;
               Dinamikus.Checked := false;
          end;
        s3:= 'override; ';
     end
     else
         s3:='';
     if Dinamikus.Checked then
     begin
          if uzenet.Checked then
          begin
               Virtualis.Checked := false;
               Overrides.Checked := false;
          end;
        Virtualis.Checked := false;
        s4:= 'dynamic; ';
     end
     else
         //Virtualis.Checked := true;
         s4:='';
     if uzenet.Checked then
     begin
        Abstrack.Enabled := false;
        Param.Text:='var Msg:TMessage';
        s2:= '';
        ComboBox2.Enabled := true;
        s5:= 'Message ' + ComboBox2.Text + ';';
     end
     else
     begin
        Abstrack.Enabled := true;
        Param.Text:='valami: TObject';
        ComboBox2.Enabled := false;
        s5:= '';
     end;
     s:= s1+s2+s3+s4+s5;
     case RadioGroup1.ItemIndex of
       0: begin
               ComboBox1.Enabled:= false;
               Memo1.Text:= 'procedure '+Nev.Text+'('+Param.Text+'); '+ s;
          end;
       1: begin
               ComboBox1.Enabled:= true;
               Memo1.Text:= 'function '+Nev.Text+'('+Param.Text+'): '+ComboBox1.Text+'; '+ s;
          end;
     end;

end;

procedure TForm1.FormCreate(Sender: TObject);
begin
     s:=''; s1:=''; s2:=''; s3:=''; s4:=''; s5:= '';
     RadioGroup1Click(self);
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
     Memo1.SelectAll;
     Memo1.CopyToClipboard;
end;

procedure TForm1.ComboBox2Change(Sender: TObject);
begin
     //ComboBox2.DroppedDown := true;
end;

end.
